﻿using System;
using Microsoft.Synchronization.SimpleProviders;

namespace Microsoft.WindowsAzure.Accelerator.Synchronization
{
    /// <summary>
    /// Contains the basic information about a synced blob.
    /// </summary>
    internal struct CloudSyncAttributes
    {
        internal DateTime LastModifiedUtc;
        internal String Name;
        internal String ETag;

        /// <summary>
        /// Initializes a new instance of the <see cref="CloudSyncAttributes"/> struct.
        /// </summary>
        /// <param name="name">The name.</param>
        /// <param name="lastModifiedUtc">The last modified time.</param>
        /// <param name="eTag">The eTag.</param>
        internal CloudSyncAttributes(String name, DateTime lastModifiedUtc, String eTag)
        {
            Name = name;
            LastModifiedUtc = lastModifiedUtc.ToUniversalTime();
            ETag = eTag;
        }
    }
}