﻿using System;

namespace Microsoft.WindowsAzure.Accelerator.Synchronization
{
    /// <summary>
    /// Gets the key names used by the synchronization providers to map betweeen
    /// file attributes and blob storage metatdata.
    /// </summary>
    internal static class CloudSyncKeys
    {
        public const String FileNameKey = "FileName";
        public const String AttributesKey = "Attributes";
        public const String CreationTimeKey = "CreationTime";
        public const String LastAccessTimeKey = "LastAccessTime";
        public const String LastWriteTimeKey = "LastWriteTime";
        public const String RelativePathKey = "RelativePath";
        public const String PathWithNameKey = "PathWithName";
        public const String SizeKey = "Size";
        public const String IsDirectory = "IsDirectory";
    }
}