namespace Microsoft.WindowsAzure.Accelerator.Synchronization
{

    /// <summary>
    /// Supported types of blob to local synchronization providers.
    /// </summary>
    public enum SyncProviderType
    {
        /// <summary>
        /// Use the blob synchronization provider based on Steve Marx (smarx.com) blog post.
        /// </summary>
        BlobSync,
        /// <summary>
        /// Use the cloud synchronization provider based on Microsoft Synchronization services.
        /// </summary>
        CloudSync
    }
}