:Init
@setlocal ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION
@pushd %~dp0
@prompt $_
@echo off

if "%1" == "" goto Usage
if "%1" == "/?" goto Usage
if "%1" == "-?" goto Usage
goto SetDefaults

:Usage
@echo Encapsulates the default options for building and packaging the Accelerator 
@echo solution for deployment to Azure or testing in the local emulator.
@echo.
@echo BUILD /p | /r
@echo.
@echo   /p          Package the solution for deployment to Azure.
@echo   /r          Builds and starts the solution for in the local emulation
@echo               environment.           
@echo.
@goto End

:SetDefaults
if     "%_serviceName%"=="" set _serviceName=Service
if        "%_roleName%"=="" set _roleName=WebRole
if    not exists "%_csdef%" set _csdef=%~dp0%_serviceName%Definition.csdef
if    not exists "%_cscfg%" set _csdef=%~dp0%_serviceName%Configuration.cscfg
if    not exists "%_accfg%" set _csdef=%~dp0%_serviceName%Accelerator.accfg
if           "%_cspkg%"=="" set _cspkg=%~dp0%_serviceName%.cspkg
if             "%_csx%"=="" set _csx=%~dp0%_serviceName%.csx
if not exists "%_roleBins%" set _roleBins=%~dp0
if  not exists "%_roleDll%" set _roleDll=%_roleBins%%_roleName%.dll

:Package
if "%1"=="/p" (
	@echo Packaging the solution for upload to Azure...
	cspack.exe %_csdef% /role:%_roleName%;"%_roleBins%";"%_roleDll%" /out:"%_cspkg%"
	@echo Packaging Completed!
	goto End
) 
if "%1"=="/r" (
	@echo Building the solutions for local testing....
	cspack.exe %_csdef% /role:%_roleName%;"%_roleBins%";"%_roleDll%" /out:"%_csx%" /copyonly
	@echo Build Completed!
	@echo Starting solution in local Azure compute emulation environment...
	csrun.exe "%_csx%" "%_cscfg%" /launchBrowser
)

:End
popd