@echo off
@rem
@rem Windows Azure & Visual Studio 2010 ~ Combined SDK Environment x64
@rem ~ Ryan D. Marshall
@rem

:SetPaths
call :SetRoot "%~dp0..\..\"
set ServiceHostingSDKInstallPath=%ProgramFiles%\Windows Azure SDK\v1.3\
set _azureSDK=%ServiceHostingSDKInstallPath%bin\
set _buildFolder=%_acceleratorSolution%Resources\Build
set _schemaFolder=%_acceleratorSolution%Resources\Schema
set _thirdPartyFolder=%_acceleratorSolution%Resources\ThirdParty
set _documentationFolder=%_acceleratorSolution%Resources\Documentation

:CheckFramework
if exist "%SystemRoot%\Microsoft.NET\Framework64\v3.5" goto :Setup64
if exist "%SystemRoot%\Microsoft.NET\Framework\v3.5"   goto :Setup32
@echo Please install the .NET 3.5 Framework.
goto :eof

:Setup64
call "%ProgramFiles(x86)%\Microsoft Visual Studio 10.0\VC\vcvarsall.bat" amd64
set path=%_azureSDK%;%_azureSDK%devstore;%SystemRoot%\Microsoft.NET\Framework64\v3.5;%path%
goto :SetupCommon

:Setup32
call "%ProgramFiles(x86)%\Microsoft Visual Studio 10.0\VC\vcvarsall.bat"
set path=%_azureSDK%;%_azureSDK%devstore;%SystemRoot%\Microsoft.NET\Framework\v3.5;%path%
call :setroot "%_azureSDK%..\"
goto :SetupCommon

:SetupCommon
set path=%_acceleratorSolution%Resources\Build;%_acceleratorSolution%Resources\Scripts;%_acceleratorSolution%Resources\ThirdParty;%path%
cd /D "%_acceleratorSolution%"
if "%1"=="/q" goto :eof

:Welcome
echo Windows Azure and Visual Studio 2010 ~ Combined SDK Environments 
echo Ryan D. Marshall (ryan.marshall@slalom.com)
title Windows Azure and Visual Studio 2010 SDK Environment
color 74
goto :eof

:SetRoot
@rem
@rem Gets the fully qualified absolute path without the '..'.
@rem This returns to the call location since it hits eof.
@rem
set _acceleratorSolution=%~fp1
goto :eof