@ECHO OFF
REM ENVIRONMENT SETUP
FOR /f "tokens=1,2 delims=@" %%a in ("%User ID%") do set dbUsr=%%a&set dbServer=%%b
SET dbName=%Database%
SET dbAdminUsr=%dbUsr%
SET dbAdminPwd=%Password%
SET dbPwd=%Password%
SET dbServerConnection=%Server% 
SET dbServerAdmin=%dbAdminUsr%@%dbServer%
 
@ECHO.
@ECHO -- ENVIRONMENT SETTINGS --
@ECHO  SQL Server Con:   %dbServerConnection%
@ECHO  SQL Server Admin: %dbServerAdmin%
@ECHO  SQL Server:       %dbServer%
@ECHO  SQL Database:     %dbName%
@ECHO  Admin User:       %dbAdminUsr%
@ECHO  Admin Password:   %dbAdminPwd%
@ECHO  Umbraco User:     %dbUsr%
@ECHO  Umbraco Password: %dbPwd%

@ECHO.
@ECHO -- DATABASE: CREATING --
@SQLCMD -U %dbServerAdmin% -P %dbAdminPwd% -S %dbServerConnection% -d master -i "%~dp0..\Sql\CreateDatabase.sql" -r0 -e -o "%~dp0..\Logs\%dbServerAdmin%.createdatabase.log"

@ECHO -- DATABASE: VERIFYING --
@SQLCMD -U %dbServerAdmin% -P %dbAdminPwd% -S %dbServerConnection% -d master -i "%~dp0..\Sql\VerifyDatabase.sql" -h-1

@ECHO.
@ECHO -- DATABASE: DEPLOYING SCHEMA --
@SQLCMD -U %dbServerAdmin% -P %dbAdminPwd% -S %dbServerConnection% -d %dbName% -i "%~dp0..\Sql\CreateSchema.sql" -r0 -e -o "%~dp0..\Logs\%dbServerAdmin%.createschema.log"

@ECHO.
@ECHO -- DATABASE: SETTING SECURITY --
@SQLCMD -U %dbServerAdmin% -P %dbAdminPwd% -S %dbServerConnection% -d %dbName% -i "%~dp0..\Sql\CreateUser.sql" -r0 -h-1 -e -o "%~dp0..\Logs\%dbServerAdmin%.roles.log"

@ECHO.
@ECHO -- STORAGE: UPLOADING SERVICE CONFIGURATION --
@"%~dp0..\bin\accelcon.exe" /q /u "%~dp0..\ServiceConfiguration.cscfg" %AcceleratorContainerSyncUri%/ServiceConfiguration.cscfg

@ECHO.
@ECHO -- STORAGE: UPLOADING SOLUTION ENGINE --
@"%~dp0..\bin\accelcon.exe" /q /u /b "%~dp0..\Packed\Service.cspkg" %AcceleratorContainerSyncUri%/Service.cspkg

@ECHO.
@ECHO -- STORAGE: UPLOADING CLOUD DRIVE --
@"%~dp0..\bin\accelcon.exe" /u /v "%~dp0..\Packed\Umbraco.vhd" %AcceleratorDrivePageBlobUri%

@ECHO.
@ECHO ==============================================
@ECHO  Deployment Complete
@ECHO.
@ECHO  Return to the Azure management interface and
@ECHO  provision a new staging service. The solution
@ECHO  package and service configuration file have
@ECHO  already been uploaded to Azure. The provision-
@ECHO  ing tools will allow you to select these 
@ECHO  existing files from Azure storage services
@ECHO  instead of uploading from your local system.
@ECHO.
@ECHO ==============================================
REM   December, 2010                         (i|rdm)