@ECHO OFF
@ECHO.
@ECHO ==============================================
@ECHO Rapid Provisioning of SQL Azure for Umbraco.
@ECHO ==============================================

REM ENVIRONMENT SETUP
FOR /f "tokens=1,2 delims=@" %%a in ("%User ID%") do set dbUsr=%%a&set dbServer=%%b&set
SET dbName=%Database%
SET dbAdminUsr=%dbUsr%
SET dbAdminPwd=%Password%
SET dbPwd=%Password%
SET dbServerConnection=%Server% 
SET dbServerAdmin=%dbAdminUsr%@%dbServer%

REM @SET 
@ECHO.
@ECHO ENVIRONMENT SETTINGS
@ECHO.
@ECHO  SQL Server Con:   %dbServerConnection%
@ECHO  SQL Server Admin: %dbServerAdmin%
@ECHO  SQL Server:       %dbServer%
@ECHO  SQL Database:     %dbName%
@ECHO  Admin User:       %dbAdminUsr%
@ECHO  Admin Password:   %dbAdminPwd%
@ECHO  Umbraco User:     %dbUsr%
@ECHO  Umbraco Password: %dbPwd%

@ECHO.
@ECHO CREATING DATABASE
SQLCMD -U %dbServerAdmin% -P %dbAdminPwd% -S %dbServerConnection% -d master -i "%~dp0Sql\CreateDatabase.sql -h-1"

@ECHO.
@ECHO CREATING SCHEMA
SQLCMD -U %dbServerAdmin% -P %dbAdminPwd% -S %dbServerConnection% -d %dbName% -i "%~dp0Sql\CreateSchema.sql"

@ECHO.
@ECHO CREATING LOGINS & ROLES
@SQLCMD -U %dbServerAdmin% -P %dbAdminPwd% -S %dbServerConnection% -d %dbName% -i "%~dp0Sql\CreateUser.sql" -e
ECHO ON

@ECHO.
@ECHO UPLOADING SOLUTION ENGINE
"%~dp0bin\accelcon.exe" /q /u /b "%~dp0Packed\Service.cspkg" %AcceleratorContainerSyncUri%/Service.cspkg

@ECHO.
@ECHO UPLOADING SERVICE CONFIGURATION
"%~dp0bin\accelcon.exe" /q /u "%~dp0ServiceConfiguration.cscfg" "%AcceleratorContainerSyncUri%/ServiceConfiguration.cscfg"

@ECHO.
@ECHO UPLOADING CLOUD DRIVE
@"%~dp0bin\accelcon.exe" /u /v "%~dp0Packed\Umbraco.vhd" "%AcceleratorDrivePageBlobUri%"

@ECHO.
@ECHO ==============================================
@ECHO Rapid Provisioning of Umbraco Completed.
@ECHO.
@ECHO If there were no serious errors, return to the
@ECHO Azure Hosting services management interface
@ECHO and provision the new staging service to run
@ECHO Umbraco.
@ECHO.
@ECHO The solutions configuration and engine package
@ECHO have already been uploaded to the account 
@ECHO storage services.  The provisioning tools will
@ECHO allow you to select these existing files in
@ECHO your Azure storage servics (instead of upload
@ECHO from your local system).
@ECHO.
@ECHO ==============================================
REM   December, 2010                         (i|rdm)